/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#ifndef _EXPORT_
#define _EXPORT_


#include "_settings_/compileSettings.h"


// export functions, if build as dll
// or import function for dll usage
#undef  WS2_32_API
#ifdef _EXPORT_DLL_ 
    #define WS2_32_API extern "C" __declspec(dllexport)
#else
    #ifdef _IMPORT_DLL_
        #define WS2_32_API extern "C" __declspec(dllimport)
    #else
        #define WS2_32_API
    #endif _IMPORT_DLL_
#endif _EXPORT_DLL_


WS2_32_API bool setPorts(int objAddr, int controlePort, int dataPort);

WS2_32_API bool addUser(int objAddr, char *user, char *password, char *folder, bool folderWritable);

WS2_32_API bool start(int objAddr);

WS2_32_API bool stop(int objAddr);


//
// redefined function headers:
//
#include "serverObjList.h"

#ifndef _IMPORT_DLL_
    #include "serverObj.h"
#endif _IMPORT_DLL_


//////////////////////////////////////////////////
void initServerObjList();                       // init our (thread-) gloabl list
                                                // MUST BE CALLED FIRST  -  app will crash elsewise

WS2_32_API int newServerObj();                  // add a new server obj to our (thread-) gloabl list
                                                // returns obj address as a handle

WS2_32_API bool removeServerObj(int objAddr);   // remove a server obj from our (thread-) gloabl list
                                                // will faild if addr is not valid
                                                // will return as soon as server has exited

WS2_32_API bool isValidServerObj(int objAddr);  // returns true, if given addr is a valid handle

//////////////////////////////////////////////////


#endif _EXPORT_
