/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#include "convertUtil.h"


string intToString(int integer)
{
    string retVal = "";
    char chr[65];

    _itoa_s(integer, chr, sizeof(chr), 10);

    for (unsigned int i = 0; i < strlen(chr); i++)
        retVal += chr[i];

    return retVal;
}
string intToStr(int integer) { 
    return intToString(integer);
}



string intToString(long long integer)
{
    string retVal = "";
    char chr[65];

    _i64toa_s(integer, chr, sizeof(chr), 10);

    for (unsigned int i = 0; i < strlen(chr); i++)
        retVal += chr[i];

    return retVal;
}
string intToStr(long long integer) { 
    return intToString(integer);
}


//
// put filler char infront of string till it reaches requested length
//
void fillString(string *str, char filler, unsigned int len)
{
    for (unsigned int i = str->size(); i < len; i++)
        *str = filler + *str;
}


//
// assembles a 64 bit integer from its low and high part
//
void int32To64(long low, long high, long long &i64)
{
    i64 = (long long) high * ((long long) MAXDWORD + 1) + low;
}


//
// splits a 64 bit integer to its low and high part
//
void int64To32(long long i64, long &low, long &high)
{
    low = i64 % ((long long) MAXDWORD + 1);
    high =  (long)( ((long long) i64 - low) / ((long long) MAXDWORD + 1) );
}