/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#include "export.h"


// export functions, if build as dll
#undef  WS2_32_API
#ifdef _EXPORT_DLL_  
    #define WS2_32_API __declspec(dllexport)
#else
    #define WS2_32_API
#endif _EXPORT_DLL_ 


 bool addUser(int objAddr, char *user, char *password, char *folder, bool folderWritable)
{
    if (!isValidServerObj(objAddr))
        return false;

    ((serverListObj*) objAddr)->sv.addUser(user, password, folder, folderWritable);
    return true;
}


WS2_32_API bool setPorts(int objAddr, int controlePort, int dataPort)
{
    if (!isValidServerObj(objAddr))
        return false;

    return ((serverListObj*) objAddr)->sv.setPorts(controlePort, dataPort);
}


WS2_32_API bool start(int objAddr)
{
    if (!isValidServerObj(objAddr))
        return false;

    return ((serverListObj*) objAddr)->sv.start();
}


WS2_32_API bool stop(int objAddr)
{
    if (!isValidServerObj(objAddr))
        return false;

    ((serverListObj*) objAddr)->sv.stop();
    return true;
}

