/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#ifndef _R_BUFFER_HELPER_
#define _R_BUFFER_HELPER_


//
//  object, designed to make ring buffer usage more fun :)
//
class rBufferHelper
{
private:
    unsigned int totalBufferSpace;      // buffer size
    char *buffer;                       // pointer to buffer, allocated in constructor

    unsigned int beginsAt;              // position from which the used buffer beginns
    unsigned int filledWith;            // bytes in buffer

public:
    rBufferHelper(unsigned int space);  // let's initialize our object
    ~rBufferHelper(); 

    char* getUsedBuffer();              // return position from wich buffer can be read
    char* getEmptyBuffer();             // return position from wich buffer can be written
    unsigned int freeSpace();           // return free buffer space
    unsigned int usedSpace();           // return used buffer space
    unsigned int maxWritable();         // return max bytes wirtable till buffer is full
                                        // or ring border is reached
    unsigned int maxReadable();         // return max bytes readable till buffer border
    bool added(unsigned int count);     // user added bytes to buffer
    bool removed(unsigned int count);   // user removed bytes from buffer
    void clear();                       // reset buffer values
};


#endif _R_BUFFER_HELPER_
