/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#include "timeUtil.h"

//
// compares file times. 
// returns 0 if equal; 1 if time1 > time2 and -1 if time1 < time2
//
char compareTimes(SYSTEMTIME *time1, SYSTEMTIME *time2)
{
    if (time1->wYear > time2->wYear)
        return 1;
    else if (time1->wYear < time2->wYear)
        return -1;

    if (time1->wMonth > time2->wMonth)
        return 1;
    else if (time1->wMonth < time2->wMonth)
        return -1;

    if (time1->wDay > time2->wDay)
        return 1;
    else if (time1->wDay < time2->wDay)
        return -1;

    if (time1->wHour > time2->wHour)
        return 1;
    else if (time1->wHour < time2->wHour)
        return -1;

    if (time1->wMinute > time2->wMinute)
        return 1;
    else if (time1->wMinute < time2->wMinute)
        return -1;

    if (time1->wSecond > time2->wSecond)
        return 1;
    else if (time1->wSecond < time2->wSecond)
        return -1;

    if (time1->wMilliseconds > time2->wMilliseconds)
        return 1;
    else if (time1->wMilliseconds < time2->wMilliseconds)
        return -1;

    return 0;
}


// GetLastWriteTime - Retrieves the last-write time and converts
//                    the time to a string
//
// Return value - TRUE if successful, FALSE otherwise
// hFile      - Valid file handle
// lpszString - Pointer to buffer to receive string
/*
BOOL GetLastWriteTime(HANDLE hFile, LPTSTR lpszString, DWORD dwSize)
{
    FILETIME ftCreate, ftAccess, ftWrite;
    SYSTEMTIME stUTC, stLocal;
    DWORD dwRet;

    // Retrieve the file times for the file.
    if (!GetFileTime(hFile, &ftCreate, &ftAccess, &ftWrite))
        return FALSE;

    // Convert the last-write time to local time.
    FileTimeToSystemTime(&ftWrite, &stUTC);
    SystemTimeToTzSpecificLocalTime(NULL, &stUTC, &stLocal);

    // Build a string showing the date and time.
    dwRet = StringCchPrintf(lpszString, dwSize, 
        TEXT("%02d/%02d/%d  %02d:%02d"),
        stLocal.wMonth, stLocal.wDay, stLocal.wYear,
        stLocal.wHour, stLocal.wMinute);

    if( S_OK == dwRet )
        return TRUE;
    else return FALSE;
}

*/

/*

SYSTEMTIME systime; 
                    if (!FileTimeToSystemTime(&FindFileData.ftLastWriteTime, &systime))


int (int argc, TCHAR *argv[])
{
    HANDLE hFile;
    TCHAR szBuf[MAX_PATH];

    if( argc != 2 )
    {
        printf("This sample takes a file name as a parameter\n");
        return 0;
    }
    hFile = CreateFile(argv[1], GENERIC_READ, FILE_SHARE_READ, NULL,
        OPEN_EXISTING, 0, NULL);

    if(hFile == INVALID_HANDLE_VALUE)
    {
        printf("CreateFile failed with %d\n", GetLastError());
        return 0;
    }
    if(GetLastWriteTime( hFile, szBuf, MAX_PATH ))
        _tprintf(TEXT("Last write time is: %s\n"), szBuf);
        
    CloseHandle(hFile);    
}
*/
